function addNewPayment(e, elem) {
    e.preventDefault();
    var i = 0;
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/" + admin + "/get_invoice_payment_form/" + $(elem).data('invoice-id'), function (data) {
        $('#payment_modal .modal-title').text($(elem).attr('title'));
        $('#payment_modal .modal-body').html(data);
        $('#payment_modal').modal('show');
    });
}

// remove the note form
function cancel_note(e, elem) {
    e.preventDefault();
    var $form = $(elem).closest('div[id^="notes_form_"]');
    var session_val = $form.find('input[id="notes_session"]').val();
    var client_id = session_val.split("-");
    $(elem).closest('div[id^="notes_form_"]').collapse('hide');
}

function confirm_cert_download(e, elem) {
    // for bill_on_download attorneys
    // notify admin, this cert hasn't been paid for
    if (confirm("Bill on download attorney and this certificate has not been paid for. Continue to download?")) {
        $(elem).removeAttr('onclick').siblings('a').removeAttr('onclick');
    } else {
        e.preventDefault();
    }
}

function confirm_cert_upload(e, el, message) {
    // fe_create confirmation to check the upload status before we allow processing
    var $el = $(el),
        $item = $el.closest('.fe-create-item'),
        $item_form = $item.find('.item-body form'),
        $dz_preview = $item_form.find('.dz-preview:last-child'),
        error = false,
        success = false;
    if ($item_form.length > 0) {
        // if we uploaded something cool!
        $item_form.each(function () {

            if ($(this).find('.dz-preview:last-child').hasClass('dz-error') || !$(this).find('.dz-preview:last-child').hasClass('dz-success')) {
                error = true;
            }
            if ($(this).find('.dz-preview:last-child').hasClass('dz-success')) {
                console.log($(this));
                success = true;
            }
        });
        if (error) {
            // if there was an error, return false
            alert('There was an error. Did you add all the files to upload?');
            e.preventDefault();
            return false;
        }
    }
    // no errors and success?
    if (!error && success)
        return confirm(message);

    // something wrong, do nothing
    alert('Is something missing?');
    e.preventDefault();
    return false;
}

function getAjax(url, success) {
    // USAGE: getAjax('http://foo.bar/?p1=1&p2=Hello+World', function(data){ console.log(data); });
    var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    xhr.open('GET', url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState > 3 && xhr.status === 200) success(xhr.responseText);
    };
    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhr.send();
    return xhr;
}

function get_attorneys_non_form(e, elem) {
    e.preventDefault();
    var title = typeof $(elem).data('id') == 'undefined' ? 'Add Non Registered Attorney' : $(elem).data('office-name');
    var $modal = $('#attorneys_non_modal');
    $.get("/" + admin + "/get_attorneys_non_form/" + $(elem).data('id'), function (data) {
        $modal.find('.modal-body').html(data);
        $modal.find('.modal-title').text(title);
        console.log($modal.find('.modal-title').length);
        //$modal.find('.input-phone').mask('00/00/0000');
        $modal.modal('show');
    });
}

function get_clients_details(e, elem) {
    e.preventDefault();
    var i = 0;
    var lock_type = typeof $(elem).data('lock-type') != 'undefined' ? "/" + $(elem).data('lock-type') : '';
    var $modal = $('#myModal');
    $.get("/" + admin + "/clients/get_clients_details_form/" + $(elem).data('client-id') + lock_type, function (data) {
        $modal.find('.modal-content').html(data);
        // $modal.find('#district_select').select2({
        // 	dropdownParent: $('#district_select_container')
        // });
        $modal.modal('show');
    });
}

function get_clients_watchlist_form(e, elem) {
    e.preventDefault();
    var i = 0;
    var title = typeof $(elem).data('client-id') == 'undefined' ? 'New Watch List' : 'Watch List: ' + $(elem).data('client-name');
    var $modal = $('#waitlist_modal');

    getAjax("/" + admin + "/clients/watchlist/get_clients_watchlist_form/" + $(elem).data('client-id'), function (data) {
        console.log(data);
        $modal.find('.modal-body').html(data);
        $modal.find('.modal-title').text(title);
        //console.log($modal.find('.modal-title').length);
        $modal.find('.date-format').mask('00/00/0000');
        $modal.find('#attorney_id').select2({
            dropdownParent: $('#waitlist_modal')
        });
        $modal.modal('show');
    });
}

function get_clients_locked_details(e, elem) {
    if (typeof (lock_type) === 'undefined') lock_type = false; // queue | create | questions
    e.preventDefault();
    var $this = $(elem),
        client_id = $this.data('client-id'),
        admin_id = $this.data('admin-id'),
        lock_type = $this.data('lock-type'),
        lock_intent = false,
        override = false,
        csrfToken = $('[name="csrf_test_name"]').val();
    var params = {
        client_id: client_id,
        admin_id: admin_id,
        lock_type: lock_type,
        lock_intent: lock_intent,
        csrf_test_name: csrfToken
    };
    postAjax("/" + admin + "/set_clients_lock", params, function (response) {
        var obj = JSON.parse(response);
        $('[name="csrf_test_name"]').val(obj.csrfHash);
        //console.log(data);
        //console.log(obj);
        if (obj.clients_lock !== null) {
            if (Object.keys(obj.clients_lock).length > 0) {
                // locked make changes to the modal
                if (obj.clients_lock['admin_id'] != admin_id) {
                    // if we are not the ones who locked it, alert the user
                    alert(obj.title);
                }
                $this.closest('.modal').find('.modal-header').addClass('bg-danger text-white');
                //$this.removeClass('btn-light').addClass('btn-danger active').attr('title', 'Unlock').find('i').removeClass('fa-lock-open-alt').addClass('fa-lock-alt');
            }
        } else {
            // unlocked make changes to the modal
            $this.closest('.modal').find('.modal-header').removeClass('bg-danger text-white');
            //$this.addClass('btn-light').removeClass('btn-danger active').attr('title', 'Lock').find('i').removeClass('fa-lock-alt').addClass('fa-lock-open-alt');
        }
        $this.replaceWith(obj.html);
    });
    return false;
    $.post("/" + admin + "/set_clients_lock/", {
        client_id: client_id,
        admin_id: admin_id,
        lock_type: lock_type,
        lock_intent: lock_intent
    }, function (data) {
        var obj = JSON.parse(data);
        //console.log(data);
        //console.log(obj);
        if (obj.clients_lock !== null) {
            if (Object.keys(obj.clients_lock).length > 0) {
                // locked make changes to the modal
                if (obj.clients_lock['admin_id'] != admin_id) {
                    // if we are not the ones who locked it, alert the user
                    alert(obj.title);
                }
                $this.closest('.modal').find('.modal-header').addClass('bg-danger text-white');
                //$this.removeClass('btn-light').addClass('btn-danger active').attr('title', 'Unlock').find('i').removeClass('fa-lock-open-alt').addClass('fa-lock-alt');
            }
        } else {
            // unlocked make changes to the modal
            $this.closest('.modal').find('.modal-header').removeClass('bg-danger text-white');
            //$this.addClass('btn-light').removeClass('btn-danger active').attr('title', 'Lock').find('i').removeClass('fa-lock-alt').addClass('fa-lock-open-alt');
        }
        $this.replaceWith(obj.html);
        //get_clients_details(e, elem);
        // if we are the "locker" OR we are not the locker but we "ok" the warning
        // show us the client details

    });
    /*$.get("/"+admin+"/get_clients_locked_details/"+$(elem).data('client-id'), function (data) {
        $.get("/" + admin + "/get_clients_details_form/" + $(elem).data('client-id'), function (data) {
            $('#myModal .modal-content').html(data);
            $('#myModal').modal('show');
            if (!data.locked || (data.locked && confirm('This queue has been locked, are you sure you want to continue?')))
                get_clients_details(e, elem);
        });
    });*/
}

function get_mailing_group_emails(e, elem) {
    e.preventDefault();
    $.get("/" + admin + "/mailing/list/" + $(elem).val(), function (data) {
        if ($('#state').length > 0) {
            $('#state').val('');
        }
        $('#email-list').html(data);
    });
}

function get_mailing_state_emails(e, elem) {
    e.preventDefault();
    $.get("/" + admin + "/mailing/list/" + $(elem).val(), function (data) {
        if ($('#mailing_group_id').length > 0) {
            $('#mailing_group_id').val('');
        }
        $('#email-list').html(data);
    });
}

function get_nav_counts() {
    if ($('body.admin').length > 0) {
        $.get("/" + admin + "/get_nav_activity", function (data) {
            var obj = JSON.parse(data)
            for (var k in obj) {
                if (obj[k] == 0)
                    // hide the badge
                    $('.' + k).addClass('d-none');
                else
                    // show the badge
                    $('.' + k).removeClass('d-none');
                // update the value
                $('.' + k).text(obj[k]);
                //console.log(obj[k]);
            }
        });
    }
}

function get_notes_form(e, elem, modal) {

    e.preventDefault();
    if (typeof (modal) === 'undefined') modal = true;
    var id_val = typeof $(elem).data('note-id') == 'undefined' ? '' : $(elem).data('note-id');
    $.get("/" + admin + "/notes/form/" + id_val, function (response) {
        data = JSON.parse(response);
        console.log(data);
        if (modal === true) {
            $('#notes_modal .modal-body').html(data.html);
            $('#notes_modal .modal-title').text($(elem).data('title'));
            $('#notes_modal [name="redirect"]').val($(elem).data('redirect'));
            $('#notes_modal [name="session"]').val($(elem).data('session'));
            $('#notes_modal #notes_submit_link').hide();
            $('#notes_modal').modal('show');
        } else {
            $('#notes_form_' + $(elem).data('id')).html(data.html).collapse('show');
            $('#notes_form_' + $(elem).data('id') + ' #notes_submit').hide();
            $('#notes_form_' + $(elem).data('id') + ' [name="redirect"]').val($(elem).data('redirect'));
            $('#notes_form_' + $(elem).data('id') + ' [name="session"]').val($(elem).data('session'));
        }
    });
}

/*function set_attorney_file(e, elem, id){
	e.preventDefault();
	var value = $(elem).is(':checked') ? 1 : 0;
	$.get("/"+admin+"/attorneys/file/"+id+"/"+value, function (data) {

	});
}

function set_attorney_bill_on_download(e, elem, id){
	e.preventDefault();
	var value = $(elem).is(':checked') ? 1 : 0;
	$.get("/"+admin+"/attorneys/bill/"+id+"/"+value, function (data) {

	});
}*/

function get_paypal_issue(e, elem) {
    e.preventDefault();
    var $modal = $('#paypalIssuesModal');
    $.get("/" + admin + "/paypal/get_paypal_issues/" + $(elem).data('id'), function (data) {
        $modal.find('.modal-content').html(data);
        // $modal.find('.modal-title').html($(elem).attr('title'));
        // $modal.find('.modal-body').html(data);
        $modal.modal('show');
    });
}

function hide_edits(e, elem) {
    // will hide the form field and restore any "edit" link associated with it
    // DEPRECIATED
    e.preventDefault();
    var target = $(elem).attr('name')
    $('[rel="' + target + '"] .static_value').text($(elem).val());
    $('[name="' + target + '"], [rel="' + target + '"]').toggleClass('d-none');
}

function mailing_send_to_list() {
    var list = $('#email-list').text().split(",");
    var idx = 0;
    // put one here to start mailing immediately while setInterval queues up
    mailing_send_email($.trim(list[idx]), idx, $('#mailing_group_id').val());
    //console.log($.trim(list[idx])+', '+idx, $('#mailing_group_id').val());
    idx++;
    var timer = setInterval(function () {
        if (idx === list.length) {
            clearInterval(timer);
            alert('done');
            return false;
        }
        mailing_send_email($.trim(list[idx]), idx, $('#mailing_group_id').val());
        console.log($.trim(list[idx]) + ', ' + (idx + 1) + ' =? ' + list.length);
        idx++;
        if (idx === list.length) {
            clearInterval(timer);
            alert('done');
            return false;
        }
    }, 15000);
}

function mailing_send_email(email, idx, group_id) {
    var params = {
        email: email,
        group_id: group_id,
        subject: $("#subject").val(),
        message: $("#message").val()
    }
    console.log(params);
    //if(email == 'max@butterflyfe.com'){
    $.post("/" + admin + "/mailing_send/", params, function (data) {
        //console.log(data);
        $('#email-list small:eq(' + idx + ')').prepend('<span class="text-success fa fa-check"></span> ');
    });
    //}
}

function postAjax(url, data, success) {
    var params = typeof data == 'string' ? data : Object.keys(data).map(
        function (k) {
            return encodeURIComponent(k) + '=' + encodeURIComponent(data[k])
        }
    ).join('&');

    var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
    xhr.open('POST', url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState > 3 && xhr.status == 200) {
            success(xhr.responseText);
        }
    };
    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.send(params);
    return xhr;
}

function set_attorney_option(e, elem, id) {
    e.preventDefault();
    var value = null;
    var field = $(elem).attr('name');
    var csrfToken = $('[name="csrf_test_name"]').val();
    var return_value = true;
    var ajax = new XMLHttpRequest();

    if (!$(elem).is(':checked') && $(elem).attr('name') == 'butterfly_fe_file') {
        var return_value = confirm("Are you sure the attorney does not want us to file their certificates with the court?");
        $(elem).prop("checked", !return_value);
    }
    if ($(elem).attr('type') == 'checkbox') value = $(elem).is(':checked') ? 1 : 0;
    else value = $(elem).val();
    var params = {'id': id, 'field': field, 'value': value, 'csrf_test_name': csrfToken};
    if (return_value) {
        postAjax("/" + admin + "/attorneys/option", params, function (response) {
            console.log(response)
        });
        /*ajax.open('get', "/" + admin + "/attorneys/option/" + id + "/" + field + "/" + value);
        ajax.addEventListener('load', (e) => {
            //handle the response here
            //var o = JSON.parse(e.responseText);
        }, false);
        ajax.send();*/
    }
}

// function set_attorney_status(e,elem,id){
// 	e.preventDefault();
// 	var value = $(elem).is(':checked') ? 1 : 0;
// 	$.get("/"+admin+"/attorneys/status/"+id+"/"+value, function (data) {
//
// 	});
// }

function set_billing_charge_attorney(e, elem) {
    // changes the attorney on the billing charge to another attorney if needed
    e.preventDefault();
    var $this = $(elem);
    var client_session_val = $this.data('client-session');
    var attorney_code_val = $this.val();
    $.post('/' + admin + '/set_billing_charge_attorney', {
        client_session: client_session_val,
        attorney_code: attorney_code_val
    }, function (data) {
        if (data == 'An error occurred and the attorney was not set! Send Max for help!')
            alert('An error occurred and the attorney was not set! Send Max for help!');
        else
            alert('Attorney has been set!');
    });
}

function set_caption(e, elem) {
    e.preventDefault();
    var id = $(elem).data('id');
    var value = $(elem).is(':checked') ? 1 : 0;
    var result;
    var vid = document.getElementById('video_player');
    $.get("/" + admin + "/captions_set_time/" + id + "/" + vid.currentTime, function (data) {
        result = $.parseJSON(data);
        $(elem).closest('.caption-row').find('.timestamp').text(result.capTime);
    });
}

function setChargesOption(e, elem) {
    var value = null;
    var id = $(elem).data('charge-id');
    var sessionType = $(elem).data('session-type');
    var field = $(elem).attr('name');
    var message = $(elem).data('message');
    var csrfToken = $('[name="csrf_test_name"]').val();
    if ($(elem).attr('type') === 'checkbox') value = $(elem).is(':checked') ? 1 : 0;
    else value = $.trim($(elem).val()).length > 0 ? $(elem).val() : 'null';

    if (!confirm(message)) {
        elem.checked = false; // reset first
        e.preventDefault();
        return false;
    } else {
        var params = {
            'charge_id': id,
            'field': field,
            'value': value,
            'session_type': sessionType,
            'csrf_test_name': csrfToken
        };
        $('#progressModal').modal('show');
        postAjax("/" + admin + "/set_charges_option", params, function (response) {
            console.log(response);
            data = JSON.parse(response);
            $('[name="csrf_test_name"]').val(data.csrfHash);
            $('#progressModal').modal('hide');
            console.log('yay');
        });
        e.stopPropagation();
        return false;
    }

}

function set_client_option(e, elem) {
    e.preventDefault();
    var value = null;
    var id = $(elem).data('client-id');
    var field = $(elem).attr('name');
    var csrfToken = $('[name="csrf_test_name"]').val();
    if (field == 'flag_date') {
        if (!$(elem).hasClass('active')) {
            if (!confirm("Are you sure you want to flag this client?"))
                return false;
        } else {
            window.location = "/" + admin + "/clients/flagged";
            return false;
        }
    }
    var $icon = $(elem).siblings('.icon-notification');
    if ($(elem).attr('type') === 'checkbox') value = $(elem).is(':checked') ? 1 : 0;
    else value = $.trim($(elem).val()).length > 0 ? $(elem).val() : 'null';
    $icon.removeClass('d-none');
    $('#progressModal').modal('show');
    var params = {'id': id, 'field': field, 'value': value, 'csrf_test_name': csrfToken};
    postAjax("/" + admin + "/clients/set_clients_option", params, function (response) {
        data = JSON.parse(response);
        $('[name="csrf_test_name"]').val(data.csrfHash);
        if (field === 'flag_date') {
            $(elem).toggleClass('active');
            if ($(elem).hasClass('btn-danger')) {
                $(elem).removeClass('btn-danger').addClass('btn-light').text('Flag');
            } else {
                $(elem).removeClass('btn-light').addClass('btn-danger').text('Flagged');
            }
        }
        $('#progressModal').modal('hide');
    });
    return false;
    // Post
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", "/" + admin + "/clients/set_clients_option", true);
    xhttp.setRequestHeader('Accept', 'application/json, text/javascript, */*; q=0.01');
    xhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
    xhttp.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhttp.setRequestHeader('X-CSRF-TOKEN', csrfToken);
    xhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            // Response
            var response = this.responseText;
        }
    };
    xhttp.send(params);
    return false;
    $.ajax({
        url: "/" + admin + "/clients/set_clients_option",
        method: 'POST',
        headers: {
            'X-Requested-With': 'XMLHttpRequest',
            'X-CSRF-TOKEN': csrfToken
        },
        dataType: 'json',
        data: {id: id, field: field, value: value, csrf_test_name: csrfToken},
        success: function (resp) {
            $('[name="csrf_test_name"]').val(resp.csrfHash);
            $('#progressModal').modal('hide');
            return true;
        }
    });
    return false;
}

function set_county_district() {

}

function set_note(e, elem) {
    e.preventDefault();
    var $form = $(elem).closest('form');
    var $notes_area = $form.closest("[id^=notes_area]");
    //var id_val = $form.find('input[id="notes_id"]').val();
    var session_val = $form.find('input[id="notes_session"]').val();
    var client_id = session_val.split("-");
    //var note_val = $form.find('textarea[id="note"]').val();
    //var csrfToken = $('[name="csrf_test_name"]').val();
    var params = {
        'id': $form.find('input[id="notes_id"]').val(),
        'session': session_val,
        'note': $form.find('textarea[id="note"]').val(),
        'csrf_test_name': $('[name="csrf_test_name"]').val()
    };
    postAjax("/" + admin + "/notes/edit", params, function (response) {
        data = JSON.parse(response);
        //console.log(data);
        $('[name="csrf_test_name"]').val(data.csrfHash);
        //$('#notes_form_' + client_id[2]).collapse('hide');
        cancel_note(e, elem);
        $notes_area.removeClass('d-none');
        $notes_area.find('#notes_table_body').html(data.html);
    });
}

function set_search_date(e, elem) {
    e.preventDefault();
    $this = $(elem);
    $.get("/" + admin + "/get_dashboard_activity/" + $('#search_from_date').val().replace(/\//g, '-') + "/" + $('#search_to_date').val().replace(/\//g, '-'), function (data) {
        console.log(data);
        $('#results').html(data);
        //dashboard client activity

        if (Highcharts) {
            Highcharts.theme = {
                colors: ['#058DC7', '#96557d', '#b4ddee', '#dfccd8', '#24CBE5', '#64E572',
                    '#FF9655', '#FFF263', '#6AF9C4'],
                title: {
                    style: {
                        color: '#000',
                        font: 'bold 16px "Trebuchet MS", Verdana, sans-serif'
                    }
                },
                subtitle: {
                    style: {
                        color: '#666666',
                        font: 'bold 12px "Trebuchet MS", Verdana, sans-serif'
                    }
                },

                legend: {
                    itemStyle: {
                        font: '9pt Trebuchet MS, Verdana, sans-serif',
                        color: 'black'
                    },
                    itemHoverStyle: {
                        color: 'gray'
                    }
                }
            };

            Highcharts.setOptions(Highcharts.theme);
            $('#client_activity_hourly').highcharts({
                data: {
                    table: 'client_activity_hourly_table'
                },
                chart: {
                    type: 'spline'
                },
                credits: {
                    enabled: false
                },
                title: {
                    text: 'Hourly Client Activity'
                },
                yAxis: {
                    allowDecimals: false,
                    title: {
                        text: 'Units'
                    }
                },
                tooltip: {
                    formatter: function () {
                        return '<b>' + this.point.name + '</b><br/>' +
                            this.series.name + ': ' + this.point.y;
                    }
                }
            });
            $('#client_activity_weekly').highcharts({
                data: {
                    table: 'client_activity_weekly_table'
                },
                chart: {
                    type: 'spline'
                },
                title: {
                    text: 'Weekly Client Activity'
                },
                yAxis: {
                    allowDecimals: false,
                    title: {
                        text: 'Units'
                    }
                },
                tooltip: {
                    formatter: function () {
                        return '<b>' + this.point.name + '</b><br/>' +
                            this.series.name + ': ' + this.point.y;
                    }
                }
            });
            $('#client_activity_monthly').highcharts({
                data: {
                    table: 'client_activity_monthly_table'
                },
                chart: {
                    type: 'spline'
                },
                title: {
                    text: 'Monthly Client Activity'
                },
                yAxis: {
                    allowDecimals: false,
                    title: {
                        text: 'Units'
                    }
                },
                tooltip: {
                    formatter: function () {
                        return '<b>' + this.point.name + '</b><br/>' +
                            this.series.name + ': ' + this.point.y;
                    }
                }
            });

            $('#client_activity_yearly').highcharts({
                data: {
                    table: 'client_activity_yearly_table'
                },
                chart: {
                    type: 'spline'
                },
                title: {
                    text: 'Yearly Client Comparison Activity'
                },
                yAxis: {
                    allowDecimals: false,
                    title: {
                        text: 'Units'
                    }
                },
                tooltip: {
                    formatter: function () {
                        return '<b>' + this.point.name + '</b><br/>' +
                            this.series.name + ': ' + this.point.y;
                    }
                }
            });
        }
    });
}

function show_edits(e, elem) {
    e.preventDefault();
    var $target = $($(elem).attr('href'));
    $($(elem).attr('href') + ', [rel="' + $(elem).attr('href').replace('#', '') + '"]').toggleClass('hide d-none');
    if ($(elem).attr('href') == '#attorney_id' || $(elem).attr('href') == '#attorney_select') {
        console.log('up');
        $target.select2({
            dropdownParent: $('#myModal')
        });
    }
}

$(function () {

    if ($('#search_atty_code').length > 0)
        $('#search_atty_code').select2();
    // show modals on load if they have class "show"
    $('.modal.in').modal('show');

    //$('.input-case-number').mask('00-00000-ZZZZZZZ', {translation:  {'Z': {pattern: /(.*)/, optional: true}}});
    //$('.input-phone').mask('200-000-0000', {translation:  {'2': {pattern: /[2-9]/, optional: false}}});
    // to fix dropdown in repsonsive table
    $('.table-responsive .table tr').on('show.bs.dropdown', function () {
        $('.table-responsive').css("overflow", "inherit");
    });

    $('.table-responsive .table tr').on('hide.bs.dropdown', function () {
        $('.table-responsive').css("overflow", "auto");
    });

    $('.table-datatable').DataTable({
        "deferRender": true,
        'dom': '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper"pi>',
        "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
        "oLanguage": {
            "sLengthMenu": "_MENU_",
            "sSearch": ""
        }
    });

    var table = $('#admin-client-datatablexxx').DataTable({
        'dom': '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper"pi>',
        "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
        "oLanguage": {
            "sLengthMenu": "Show _MENU_",
            "sSearch": "Filter"
        },
        ajax: '/' + admin + '/get_clients_list',
        "columns": [
            {
                "data": function (data) {
                    var has_spouse = $.trim(data.spouse_first_name).length > 0 && $.trim(data.spouse_last_name).length > 0 ? true : false;
                    var output = '';
                    output += '<a role="button" data-toggle="collapse" href="#" onClick="get_clients_details(event,this)" data-client-id="' + data.id + '"> ' + data.last_name + ($.trim(data.suffix).length > 0 ? ', ' + data.suffix : '') + ', ' + data.first_name + '</a>';
                    if (data.dup_count > 1) {
                        output += ' <span class="fa fa-user-times text-warning"></span>';
                    }
                    if (has_spouse) {
                        output += '<br> <small>&amp; ' + data.spouse_last_name + ($.trim(data.spouse_suffix).length > 0 ? ', ' + data.spouse_suffix : '') + ', ' + data.spouse_first_name + '</small>';
                    }
                    output += '<span class="hide d-none">' + data.last_4_ssn + (has_spouse ? ', ' + data.spouse_last_4_ssn : '') + '</span>  <span class="hide d-none">' + data.attorney_code + '</span>';
                    return output
                }
            },
            {"data": "client_session"},
            {
                "data": "session_type",
                "class": "text-center"
            },
            {
                "data": function (data) {
                    return '<span class="hide d-none">' + data.start_date + '</span> <span title="' + data.start_time + '" data-toggle="tooltip" data-placement="top" data-original-title="' + data.start_time + '">' + data.start_date_formatted + ' </span>';
                }
            },
            {
                "data": function (data) {
                    var t = new Date();
                    t.setDate(t.getDate() - 180);
                    var expire_date = (((t.getMonth() + 1) < 10) ? '0' + (t.getMonth() + 1) : (t.getMonth() + 1)) + "/" + ((t.getDate() < 10) ? '0' + t.getDate() : t.getDate()) + "/" + t.getFullYear();
                    return $.trim(data.complete_date).length > 0 ? '<span class="hide d-none">' + data.complete_date + '</span> <span title="' + (data.complete_date_formatted == expire_date ? 'Expired' : data.complete_time) + '" class="' + (data.complete_date_formatted == expire_date ? 'text-danger' : '') + '" data-toggle="tooltip" data-placement="top" data-original-title="' + data.complete_time + '">' + data.complete_date_formatted + ' </span>' : '';
                }
            },
            {
                "data": function (data) {
                    return $.trim(data.is_waived).length > 0 ? '<span class="hide d-none">' + data.is_waived + '</span> <form action="/' + admin + '/fee-waivers/waive" style="margin-bottom:0;" method="post" accept-charset="utf-8">' +
                        '<?= csrf_field() ?>' +
                        '<input type="submit" name="waive" value="Waive" class="btn btn-' + (data.is_waived == 1 ? 'success' : 'light') + ' btn-sm" style="margin-bottom:0;">' +
                        '<input type="hidden" name="charge_id" value="' + data.billing_charges_id + '">' +
                        '<input type="hidden" name="redirect" value="/' + admin + '/clients">' +
                        '<input type="hidden" name="session_type" value="' + data.session_type + '">' +
                        '</form>' : '';
                },
                "class": "text-center"
            },
            {
                "data": "paid",
                "class": "text-center"
            }

        ],
        "initComplete": function (settings, json) {
            $('[data-toggle="tooltip"]', this).tooltip();
        }
        //serverSide: true
    }).on('draw.dt', function () {
        $('[data-toggle="tooltip"]', this).tooltip();
    });

    var table = $('#admin-client-datatablex').DataTable({
        'dom': '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper"pi>',
        "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
        "oLanguage": {
            "sLengthMenu": "Show _MENU_",
            "sSearch": "Filter"
        },
        ajax: '/' + admin + '/get_clients_list',
        "columns": [
            {
                "data": function (data) {
                    var has_spouse = $.trim(data.spouse_first_name).length > 0 && $.trim(data.spouse_last_name).length > 0 ? true : false;
                    var output = '';
                    output += '<a role="button" data-toggle="collapse" href="#" onClick="get_clients_details(event,this)" data-client-id="' + data.id + '"> ' + data.last_name + ($.trim(data.suffix).length > 0 ? ', ' + data.suffix : '') + ', ' + data.first_name + '</a>';
                    if (data.dup_count > 1) {
                        output += ' <span class="fa fa-user-times text-warning"></span>';
                    }
                    if (has_spouse) {
                        output += '<br> <small>&amp; ' + data.spouse_last_name + ($.trim(data.spouse_suffix).length > 0 ? ', ' + data.spouse_suffix : '') + ', ' + data.spouse_first_name + '</small>';
                    }
                    output += '<span class="hide d-none">' + data.last_4_ssn + (has_spouse ? ', ' + data.spouse_last_4_ssn : '') + '</span>';
                    return output
                }
            },
            {"data": "client_session"},
            {
                "data": "session_type",
                "class": "text-center"
            },
            {
                "data": function (data) {
                    return '<span class="hide d-none">' + data.start_date + '</span> <span title="' + data.start_time + '" data-toggle="tooltip" data-placement="top" data-original-title="' + data.start_time + '">' + data.start_date_formatted + ' </span>';
                }
            },
            {
                "data": function (data) {
                    return $.trim(data.complete_date).length > 0 ? '<span class="hide d-none">' + data.complete_date + '</span> <span title="' + data.complete_time + '" data-toggle="tooltip" data-placement="top" data-original-title="' + data.complete_time + '">' + data.complete_date_formatted + ' </span>' : '';
                }
            },
            {
                "data": function (data) {
                    return $.trim(data.is_waived).length > 0 ? '<span class="hide d-none">' + data.is_waived + '</span> <form action="/' + admin + '/fee-waivers/waive" style="margin-bottom:0;" method="post" accept-charset="utf-8">' +
                        '<?= csrf_field() ?>' +
                        '<input type="submit" name="waive" value="Waive" class="btn btn-' + (data.is_waived == 1 ? 'success' : 'light') + ' btn-sm" style="margin-bottom:0;">' +
                        '<input type="hidden" name="charge_id" value="' + data.billing_charges_id + '">' +
                        '<input type="hidden" name="redirect" value="/' + admin + '/clients">' +
                        '<input type="hidden" name="session_type" value="' + data.session_type + '">' +
                        '</form>' : '';
                },
                "class": "text-center"
            },
            {
                "data": "paid",
                "class": "text-center"
            }

        ],
        "initComplete": function (settings, json) {
            $('[data-toggle="tooltip"]', this).tooltip();
        }
        //serverSide: true
    }).on('draw.dt', function () {
        $('[data-toggle="tooltip"]', this).tooltip();
    });

    table.on('xhr', function () {
        //var data = table.ajax.params();
        //alert( 'Search term was: '+data.search.value );
    });


    if ($('#search_from_date').length > 0) $('#search_from_date, #search_to_date').trigger('changeDate');// document.getElementById('search_from_date').dispatchEvent(event);


    $('#search_from_date, #search_to_date').datepicker()
        .on('changeDate change keyup', function (e) {
            if ($('#dashboard').length > 0)
            set_search_date(e, this);
        });
    if ($('#dashboard').length > 0) {
        $('#search_from_date, #search_to_date').trigger('changeDate');
    }

    // fixes highchart width in hidden tabs
    $(document).on('shown.bs.tab', 'a[data-toggle="tab"]', function (e) { // on tab selection event
        $("#client_activity_weekly, #client_activity_monthly").each(function () { // target each element with the .contains-chart class
            var chart = $(this).highcharts(); // target the chart itself
            chart.reflow() // reflow that chart
        });
    })

    $('#form_mailing_mass').submit(function (event) {
        event.preventDefault();
        mailing_send_to_list();
    });


});

$(document).ready(function () {
    setInterval(get_nav_counts, 60000);
    var table = $('#example').DataTable({
        'dom': '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper"pi>',
        "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
        "oLanguage": {
            "sLengthMenu": "_MENU_",
            "sSearch": "",
            "sFilterInput": '',
            "sInfoFiltered": ''
        },
        'searching': false,
        'processing': true,
        'serverSide': true,
        'ajax': {
            'url': "/" + admin + "/clients/get_clients_table/",
            'data': function (d) {
                return $.extend({}, d, {
                    'search_first_name': $('#search_first_name').val(),
                    'search_last_name': $('#search_last_name').val(),
                    'search_last_4': $('#search_last_4_ssn').val(),
                    'search_client_session': $('#search_client_session').val(),
                    'search_from_date': $('#search_from_date').val(),
                    'search_to_date': $('#search_to_date').val(),
                    'search_date_type': $('#search_date_type').val(),
                    'search_atty_code': $('#search_atty_code').val(),
                })
            }
        },
        "PaginationType": "bootstrap",
        "columns": [
            {"class": "td-client"},
            null,
            {"class": "text-center"},
            null,
            null,
            {"searchable": false},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': false},
            {'visible': false, 'searchable': false}
        ]
    });
    $('.dataTables_filter input').attr('placeholder', 'Filter');
    //table.draw();
    $('#search_first_name, #search_last_name, #search_last_4_ssn, #search_client_session, #search_from_date, #search_to_date, #search_date_type, #search_atty_code').bind('keyup changeDate change', function () {
        table.draw();
    })

    /*$('#example').DataTable({
        'dom': '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper"pi>',
        "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
        "oLanguage": {
            "sLengthMenu": "_MENU_",
            "sSearch": "",
            "sFilterInput": '',
            "sInfoFiltered": ''
        },
        "processing": true,
        "serverSide": true,
        "ajax": "/" + admin + "/clients/get_clients_table/",
        "PaginationType": "bootstrap",
        "columns": [
            {"class": "td-client"},
            null,
            {"class": "text-center"},
            null,
            null,
            {"searchable": false},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': true},
            {'visible': false, 'searchable': false},
            {'visible': false, 'searchable': false}
        ]
    });
    $('.dataTables_filter input').attr('placeholder', 'Filter');*/

});


function format(d) {
    return 'Full name: ' + d.first_name + ' ' + d.last_name + '<br>' +
        'Salary: ' + d.salary + '<br>' +
        'The child row can contain any data you wish, including links, images, inner tables etc.';
}


