const progressModal = new bootstrap.Modal(document.getElementById("progressModal"), {
    backdrop: 'static'
});

var session_modal_shown = false;
var session_time = 9000;
var googTrans = getCookie('googtrans');

//alert(googTrans);

function addCounlseingRow(e, elem) {
    e.preventDefault();
    var i = 0;
    var type = $(elem).data('type');
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/counseling/" + type + "/row/" + $('[name="type"]').val() + "/" + i, function (data) {
        $('.section').append(data);
    });
    // $.get("/counseling/" + type + "/row/" + i + "/" + $('[name="type"]').val(), function (data) {
    //     $('.section').append(data);
    // });
}

function addNewLoans(e) {
    e.preventDefault();
    var i = 0;
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/counseling/loans/row/" + i + "/" + $('[name="type"]').val(), function (data) {
        $('.section').append(data);
    });
}

function addNewDebts(e) {
    e.preventDefault();
    var i = 0;
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/counseling/debts/row/" + i + "/" + $('[name="type"]').val(), function (data) {
        $('.section').append(data);
    });
}

function addNewExpenses(e) {
    e.preventDefault();
    var i = 0;
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/counseling/expenses/row/" + i + "/" + $('[name="type"]').val(), function (data) {
        $('.section').append(data);
    });
}

function addNewMoney(e) {
    e.preventDefault();
    var i = 0;
    $('[name="id[]"]').each(function (index, element) {
        i++;
    });
    $.get("/counseling/money/row/" + i + "/" + $('[name="type"]').val(), function (data) {
        $('.section').append(data);
    });
}

function check_row_fields() {
    var has_error = false;
    $('[name="description[]"]').each(function (index, element) {
        var has_data = false;
        var row = $(this).closest('.row');
        var payment = row.find('[name="payment[]"]');
        var total = row.find('[name="total_owed[]"]');
        var monthly = row.find('[name="monthly_payment[]"]')
        if (payment.length > 0) {
            if ($.trim(payment.val()).length > 0) {
                has_data = true;
                //alert('payment data');
            } else {
                if ($.trim($(this).val()).length > 0) {
                    payment.addClass('is-invalid');
                    has_error = true;
                    //alert('payment error');
                }
            }
        }
        if (total.length > 0) {
            if ($.trim(total.val()).length > 0) {
                has_data = true;
                //alert('total data');
            } else {
                if ($.trim($(this).val()).length > 0) {
                    total.addClass('is-invalid');
                    has_error = true;
                    //alert('total error');
                }
            }
        }
        if (monthly.length > 0) {
            if ($.trim(monthly.val()).length > 0) {
                has_data = true;
                //alert('monthly data');
            } else {
                if ($.trim($(this).val()).length > 0) {
                    monthly.addClass('is-invalid');
                    has_error = true;
                    //alert('monthly error');
                }
            }
        }
        // if error show it on this description
        if (has_data && $.trim($(this).val()).length == 0) {
            $(this).addClass('is-invalid');
            has_error = true;
        }

        // if data has error (is blank) and description is blank let them pass and we will remove that entry
        /*if(!has_data && $.trim($(this).val()).length == 0){
            has_error = false;
        }*/
    });

    return !has_error;
}

function check_spouse_name(e, elem) {
    if ($(elem).val().toUpperCase() == $('input[name="first_name"]').val().toUpperCase()) {
        $('#spouse_name_alert').show();
    } else {
        $('#spouse_name_alert').hide();
    }
}

function confirm_prompt(e, elem) {
    // use the title tag to display the confirm message
    var title = $(elem).attr('title');
    if (!confirm(title)) {
        e.preventDefault();
    }
}

function confirm_remove(e, elem) {
    if (!confirm("Are you sure you want to remove this?")) {
        e.preventDefault();
    }
}

function confirm_submit(e, elem) {
    if (!confirm("Are you sure you want to invoice this?")) {
        e.preventDefault();
    }
}

function do_monthly_calc(e) {
    numeric_filter(e);
    var idx = $(e).data('index');
    if (idx != null) {
        if ($('select[data-index="' + idx + '"]').val() != 0) {
            //console.log($('.money-payment[data-index="' + idx + '"]').val() + ' * ' + $('select[data-index="' + idx + '"]').val()+' / 12 = '+(($('.money-payment[data-index="' + idx + '"]').val() * $('select[data-index="' + idx + '"]').val()) / 12));
            $('.monthly-value[data-index="' + idx + '"]').val((($('.money-payment[data-index="' + idx + '"]').val() * $('select[data-index="' + idx + '"]').val()) / 12).toFixed(2));
        } else {
            $('.monthly-value[data-index="' + idx + '"]').val('0.00');
        }
        do_total_calc();
    }
}

function do_row_delete(e, id) {
    if (id != false) {
        var idx = $(e).data('index');
        var type = $('[name="type"]').val();
        if (confirm('Are you sure?')) {
            $.get(id + "/" + type, function (data) {
                if (data == 1) {
                    $('.row[data-index="' + idx + '"]').remove();
                    do_total_calc();
                }
            });
        }
    } else {
        if (confirm('Are you sure?')) {
            $(e).closest('.row').remove();
        }
    }
    do_total_calc();
}

function do_total_calc(e) {
    numeric_filter(e);
    var total = 0.00;
    $('.monthly-value').each(function (index, element) {
        //console.log()
        total = Number($(this).val().replace(',', '')) + Number(total);
    });
    $('.monthly-total').text(Number(total).toFixed(2));
}

function dtval(d, e) {
    //value = d.value;
    //d.value = value.replace(/^([\d]{4})([\d]{2})([\d]{2})$/,"$1/$2/$3");
}

function format_money(theControl) {
    var theCount = 0;
    var theString = theControl.value;
    var newString = "";
    var myString = theString;
    var theLen = myString.length;

    //the first pass we need to go through and verify that all the characters are valid
    for (var i = 0; i < theLen; i++) {
        // Character codes for ints 1 - 9 are 48 - 57
        if ((myString.charCodeAt(i) >= 48) && (myString.charCodeAt(i) <= 57) || (myString.charCodeAt(i) == 44) || (myString.charCodeAt(i) == 46) || (myString.charCodeAt(i) == 45) || (myString.charCodeAt(i) == 36)) {
            newString = newString + myString.charAt(i);
        } else {
            //alert("The Money Value you entered " + theString + " does not contian valid characters");
            theControl.focus();
            return false;
        }
    }

    //Check to see if we have a "."
    var splitString = newString.split(".");

    //Evaluate the cents of the string, if the length is not 0 or 2 then reject
    var cents = "";
    if (splitString[1] != null) {
        if (splitString[1].length != 0 && splitString[1].length != 2) {
            //alert("The Money Value you entered " + theString + " does not contian valid characters");
            theControl.focus();
            return false;
        } else if (splitString[1].length == 0) {
            cents = "00"
        } else if (splitString[1].length == 2) {
            cents = splitString[1];
        }
    } else {
        cents = "00";
    }

    var theLen2 = splitString[0].length;
    if (theLen2 == 0) {
        theControl.value = "0";
        return true;
    }

    var newString2 = "";
    for (var i = 0; i < theLen2; i++) {
        // Character codes for ints 1 - 9 are 48 - 57
        if ((splitString[0].charCodeAt(i) >= 48) && (splitString[0].charCodeAt(i) <= 57) || (splitString[0].charCodeAt(i) == 45)) {
            newString2 = newString2 + splitString[0].charAt(i);
        }
    }

    //now put the string back to together and format it
    newString2 += '';
    x = newString2.split('.');
    x2 = x.length > 1 ? '.' + x[1] : '';
    var rgx = /(\d+)(\d{3})/;
    //while (rgx.test(x[0])) {
    //x[0] = x[0].replace(rgx, '$1' + ',' + '$2');
    //}

    theControl.value = x[0] + x2 + "." + cents;
    return true;


}

function getAjax(url, success) {
    // USAGE: getAjax('http://foo.bar/?p1=1&p2=Hello+World', function(data){ console.log(data); });
    var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    xhr.open('GET', url);
    xhr.onreadystatechange = function () {
        if (xhr.readyState > 3 && xhr.status === 200) success(xhr.responseText);
    };
    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhr.send();
    return xhr;
}

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i].trim();
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}

function get_counties_by_district_value(e, elem) {
    var district_value = $(elem).val();
    $.get("/clients/counties/" + district_value, function (data) {
        $('#county').html(data);
    });
}

function get_counties_by_state_id(e, elem) {
    var state_id = $(elem).val();
    var county_district_select_value = $('[name="county_district_select"]:checked').val();
    var $county_select = $('#county_select');
    var $district_county_id = $('#district_county_id');
    var $district_id = $('#district_id'); // #district_id after UST upgrade
    var $district_select = $('#district_select');
    // show the psinner to indicate we are doing something
    $county_select.prev('.icon-notification').removeClass('d-none');
    // hide the selectors until populated
    $('#county_select, #district_select').addClass('d-none');
    // update the county drop down depending on selection
    $.get("/clients/counties/0/" + state_id, function (response) {
        const data = JSON.parse(response);
        $district_county_id.html(data.html);
        if ($.trim($district_county_id.data('selected-id')).length > 0) {
            $district_county_id.val($district_county_id.data('selected-id'));
        }
        if($('[name="county_district_select"]:checked').val() == 0) {
            $county_select.removeClass('d-none').prevAll('.icon-notification').addClass('d-none');
            $district_select.addClass('d-none');
        }
        if(data.district_count == 1){
            // if there is only one district, hide the county / court selector since there are no options
            $('#client_form_county_court_toggle, #client_form_county_court_selector').addClass('d-none');
        } else {
            $('#client_form_county_court_toggle, #client_form_county_court_selector').removeClass('d-none');
        }
    });
    if ($district_select.length > 0) {
        // update the district dropdown
        $.get("/clients/districts/0/" + state_id, function (data) {
            $district_id.html(data); // #district_id after UST upgrade
            // #district_id after UST upgrade
            if ($.trim($district_id.data('selected-id')).length > 0) {
                $district_id.val($district_id.data('selected-id'));
            }
            if($('[name="county_district_select"]:checked').val() == 1) {
                $district_select.removeClass('d-none').prevAll('.icon-notification').addClass('d-none');
                $county_select.addClass('d-none');
            }
        });
    }
}

function get_counties_by_state_id_all(e, elem) {
    var state_id = $(elem).val();
    $.get("/clients/counties/0/" + state_id + "/1", function (data) {
        $('#district_county_id').html(data);
        // now we need to set district value
        //set_district_value_on_select(null,$('#district_county_id'))
    });
}

function numeric_filter(txb) {
    //alert(txb);
    //if(typeof(txb) === 'number')
    //txb = txb;
    if (typeof (txb) === 'object')
        txb.value = txb.value.replace(/[^0-9.]/g, '');
}

function resize_window() {
}

function send_email_results(e, el) {
    e.preventDefault();
    var $el = $(el);
    var $indicator = $el.next();
    $el.addClass('d-none');
    $indicator.addClass('d-inline-block').removeClass('d-none');// show the spinner
    $.get($el.attr('href'), function (data) {
        console.log(data);
        $indicator.replaceWith(function () {
            return data;
        });
    });
}

function session_countdown(duration) {
    var timer = duration, minutes, seconds;
    var interval = setInterval(function () {
        //console.log(timer);
        minutes = parseInt(timer / 60, 10);
        seconds = parseInt(timer % 60, 10);

        minutes = minutes < 10 ? "0" + minutes : minutes;
        seconds = seconds < 10 ? "0" + seconds : seconds;

        if (minutes < 1 && session_modal_shown == false) {
            session_modal_shown = true;
            $.get("/clients/session_handler/warn", function (data) {
                $('#modal-footer').find('.modal-content').html(data);
                $('#modal-footer').modal('show');
                $('#modal-footer .session-continue').click(function (e) {
                    e.preventDefault();
                    $.get("/clients/session_handler", function (data) {
                        //session should be refreshed
                        window.clearInterval(interval);
                        session_countdown(60 * 2);
                        $('#modal-footer').modal('hide');
                        session_modal_shown = false;
                    });
                })
            });

        }
        if (--timer < 0) {
            // kill session
            window.clearInterval(interval);
            switch (session_type) {
                case 'cc':
                    $.get("/clients/session_handler/message/session_timeout/cc/true", function (data) {
                        window.location = '/clients/recovery/cc/timeout';
                    });
                    break;
                case 'fe':
                    $.get("/clients/session_handler/message/session_timeout/fe/true", function (data) {
                        window.location = '/clients/recovery/fe/timeout';
                    });
                    break;
            }
        }
    }, 1000);
}

function set_button_disabled(event, elem) {
    // temporarily disables a button for 10 seconds
    var $elem = $(elem);
    if ($elem.hasClass('disabled')) {
        // if we are already disabled ignore this click
        event.preventDefault();
    } else {
        $elem.addClass('disabled').prepend('<i class="fas fa-redo fa-spin mr-2 me-2"></i>');
        var myInterval = setInterval(function () {
            clearInterval(myInterval);
            $elem.removeClass('disabled').find('.fa-redo').remove();
        }, 10000);
    }
}

function set_county_district(event, elem){
    // a radio button on the clients form is setting if we are selecting county or district from a drop down
    // value 0 == county and value 1 == district
    var $this = $(elem);
    var value = $this.val();
    var state_id = $('#state_id').val();
    var $district_county_id = $('#district_county_id');
    var $district_id = $('#district_id'); // #district_id after UST upgrade
    $district_county_id.prop('required', value == 0 ? true : false);
    $district_id.prop('required', value == 1 ? true : false);

    if(value == 0) {// if we are selecting a county, make districts value ""
        $district_id.val('');
        $('#county_select').removeClass('d-none');
        $('#district_select').addClass('d-none');
    }
    if(value == 1) { // if we are selecting a district, make county value ""
        console.log(value);
        $district_county_id.val('');
        $('#county_select').addClass('d-none');
        $('#district_select').removeClass('d-none');
    }

}

function setCookie(cname, cvalue, exdays) {
    //alert(cname+","+cvalue+", "+exdays);
    var expires;
    if (exdays === 0) {
        expires = '';
    } else {
        var d = new Date();
        d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
        expires = "expires=" + d.toGMTString();
    }
    var domain = (typeof domain === "undefined") ? '' : "; domain=" + domain;
    document.cookie = cname + "=" + cvalue + "; " + expires + "path=" + '/' + domain;
}


function set_district_value_on_select(e, elem) {
    //var county_id = $(elem).val();
    //$.get("/counseling/districts/" + county_id, function (data) {
        //$('#filing_district_id').val(data);
    //});
}

function setFieldValid(el){
    // removed the invalid class of an invalid input for when they make a change
    var $el = $('[name="'+$(el).attr('name')+'"]');
    $el.removeClass('is-invalid');
}

function set_good_quotes(event, elem) {
    var goodQuotes = $(elem).val()
        .replace(/[\u2018\u2019]/g, "'")
        .replace(/[\u201C\u201D]/g, '"');
    $(elem).val(goodQuotes);
}

function set_language(event, elem) {
    // changes the language of the google translator
    var $elem = $(elem);
    var lang = $elem.data('lang');
    getAjax('/clients/set/lang/'+lang, function(data){ location.reload(); });
    /*alert(lang)
    alert($('#google_translate_element select option[value='+lang+']').length);
    $('#google_translate_element select').val(lang).click();*/
    //setCookie('googtrans', '/en/' + lang, 0, '.butterflyfe.com');
    //setCookie('googtrans', '', 0, '/');
    //location.reload();
    //document.location.href = "/clients/language_change/" + lang;


}

function set_results_data(e, elem, target) {
    e.preventDefault();
    // saves the svg data so we can insert the pie chart in PDF results
    var field = $(target).data('field');
    var value = $(target).data('value');
    var href = $(elem).attr('href');
    switch (target) {
        case '#pie_chartx': {
            value = $(target).find('div').first().html();
        }
    }
    var params = {
        field: field,
        value: value,
        csrf_test_name: $('[name="csrf_test_name"]').val()
    }
    console.log(params);
    $.ajax({
        type: 'POST',
        url: '/counseling/results/set',
        data: params,
        contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
        headers: {'X-Requested-With': 'XMLHttpRequest'},
        success: function(result){
            location.href = href;
        },
        error: function(result){
            console.log(result.responseJSON);
        }
    });
    /*
    $.ajax({
        data: params,
        url: '/counseling/results/set',
        type: 'POST',
        headers: {'X-Requested-With': 'XMLHttpRequest'},
        success: function(response){
            location.href = href;
        }});
    $.post('/counseling/results/set', params, function (response) {
        location.href = href;
    })*/

}

function set_upload_form(event, elem, client_id) {
    $('#client_id').val(client_id);
}

function show_modal_content(e, elem) {
    e.preventDefault();
    // get content via ajax and display it in #modal-footer
    var params = {
        title: $(elem).attr('title'),
        slug: $(elem).data('slug'),
        page: $(elem).data('page')
    }
    var $modal = $('#modal-footer');
    $.post("/" + params['page'] + "/get_modal_content/", params, function (data) {
        //console.log(data);
        $('#modal-footer').find('.modal-content').html(data);
        $('#modal-footer').modal('show');
    });
}

function show_spouse_deceased_options(e, elem) {
    var $group = $('#deceased_spouse_group');
    switch ($(elem).val()) {
        case '0':
            $group.collapse('hide');
            break;
        case '1':
            $group.collapse('show');
            break;
    }
}

function show_spouse_options(e, elem) {
    var $filing_group = $('#filing_spouse_group');
    switch ($(elem).val()) {
        case '0':
            $filing_group.collapse('hide');
            $filing_group.find('#spouse_active0').click();
            $filing_group.find('#spouse_filing_separate0').click();
            $filing_group.find('#spouse_deceased0').click();
            break;
        case '1':
            //$active_group.collapse('show').find('[name=spouse_active]').prop('checked', false);
            $filing_group.collapse('show');
            $filing_group.find('[name=spouse_active]').prop('checked', false);
            $filing_group.find('[name=spouse_filing_separate]').prop('checked', false);
            $filing_group.find('[name=spouse_deceased]').prop('checked', false);
            break;
    }
}

function toggle_flip(e, elem) {
    e.preventDefault();
    $(elem).closest('.flip-card').toggleClass('flipped');
}

if ($('#counseling-id').length > 0 || $('#education-id').length > 0) {
    // if we are on the ID page and they use the back button, redirect instead of going back
    if (window.history && window.history.pushState) {

        history.pushState("nohb", null, "");
        $(window).on("popstate", function (event) {

            if (!event.originalEvent.state) {
                if ($('#counseling-id').length > 0) {
                    window.location = "/counseling/registration";
                }
                if ($('#education-id').length > 0) {
                    window.location = "/education/registration";
                }
                //history.pushState( "nohb", null, "" );
                //return;
            }
        });
    }
}

$(function () {

    $(window).resize(function () {
        resize_window();
    });

    /*$('[data-toggle="popover"]').popover().click(function(){
        alert();
    });*/

    const popoverTriggerList = document.querySelectorAll('[data-bs-toggle="popover"]')
    const popoverList = [...popoverTriggerList].map(popoverTriggerEl => new bootstrap.Popover(popoverTriggerEl,
        {
            container: 'body',
            trigger: 'focus',
            customClass: function(el){
                console.log(el.dataset.bsExtraclass);
                //return 'popover-info';
                return (typeof el.dataset.bsCustomclass !== 'undefined') ? el.dataset.bsCustomclass : 'popover-info';
            }
        }))

    /*var popoverTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="popover"]'))
    var popoverList = popoverTriggerList.map(function (popoverTriggerEl) {
        return new bootstrap.Popover(popoverTriggerEl, {
            container: 'body',
            trigger: 'focus'
        })
    })*/
    $('[data-toggle="tooltip"]').tooltip();
    $('body .dropdown-toggle').dropdown();
    $('.form-control').on('keydown', function () {
        if ($(this).closest('.form-group').hasClass('has-error')) {
            $(this).closest('.form-group').removeClass('has-error');
            $(this).closest('.form-group').find('small.text-danger').remove();
        }
    });
    $('[type="radio"],[type="checkbox"],select').on('click', function () {
        if ($(this).closest('.form-group').hasClass('has-error')) {
            $(this).closest('.form-group').removeClass('has-error');
            $(this).closest('.form-group').find('small.text-danger').remove();
        }
    });
    /*$('input[type=radio][name=spouse_deceased]').on('change', function() {
        var $group = $('#deceased_spouse_group');
        switch($(this).val()) {
            case '0':
                $group.collapse('hide');
            	//$('#spouse_submit_group').show();
                break;
            case '1':
                $group.collapse('show');
                //$('#spouse_submit_group').hide();
                break;
        }
    });
    $('input[type=radio][name=filed_with_spouse]').on('change', function() {
        //var $active_group = $('#spouse_active_group');
        var $filing_group = $('#filing_spouse_group');
        switch($(this).val()) {
            case '0':
                $filing_group.collapse('hide');
                $filing_group.find('#spouse_active0').click();
                $filing_group.find('#spouse_filing_separate0').click();
                $filing_group.find('#spouse_deceased0').click();
                break;
            case '1':
                //$active_group.collapse('show').find('[name=spouse_active]').prop('checked', false);
                $filing_group.collapse('show');
                $filing_group.find('[name=spouse_active]').prop('checked', false);
                $filing_group.find('[name=spouse_filing_separate]').prop('checked', false);
                $filing_group.find('[name=spouse_deceased]').prop('checked', false);
                break;
        }
    });*/
    $('select').on('change', function () {
        if ($(this).closest('.form-group').hasClass('has-error')) {
            $(this).closest('.form-group').removeClass('has-error');
            $(this).closest('.form-group').find('small.text-danger').remove();
        }
    });

    $('[name="frequency[]"]').on('change', function (e) {
        do_monthly_calc($(this).data('index'));
    });
    $('[name="payment[]"]').on('keydown', function (e) {
        do_monthly_calc($(this).data('index'));
    });
    $('[name="frequency[]"]').each(function (index, element) {
        do_monthly_calc(this);
    });
    $('select[name="state_id"]').each(function (index, element) {
        // if they refresh the page and state has been selected
        //if ($.trim($(this).val()).length != 0) get_counties_by_state_id(null, $(this));
    });

    // if you need an image on popover
    $('.popover-img').popover({
        html: true,
        content: function (el) {
            //console.log(el);
            return '<img src="' + $(el).data('img') + '" width="240" />';
        }
    });

    $('[rel="popover"]').popover({
        container: 'body',
        html: true,
        content: function () {
            var clone = $($(this).data('popover-content')).clone(true).removeClass('d-none');
            return clone;
        }
    }).click(function (e) {
        e.preventDefault();
    });
    if (typeof session_type !== 'undefined') {
        if (session_type == 'cc' || session_type == 'fe') {
            session_countdown(session_time);
        }
    }
    ;
    $('[data-popover-type]').on('show.bs.popover', function (e) {
        //console.log(e);
    })
    do_total_calc();
    resize_window();
    /*if($('.datepicker-single').length > 0) {
        console.log('changer');
        $('.datepicker-single').datepicker().on('changeDate', function (e) {
            //set_search_date(event, this);
            $(this).trigger('change');
        });
    }*/

    $(document).on('focusout', '[data-toggle="popover"]', function(){
        $('[data-toggle="popover"]').popover('hide');
    });
    // remove any invalid classes on form fields if we are changing the value
    $( "input, textarea, select, checkbox, radio" ).blur(function() {
        setFieldValid(this);
    }).change(function() {
        setFieldValid(this);
    }).click(function() {
        setFieldValid(this);
    });
});

// Nav offcanvas / toggler connection
const nav = document.getElementById('nav');
const navOffCanvas = document.getElementById('navOffCanvas');
const navToggler = document.getElementById('navToggler');
if(navOffCanvas != null) {
    navOffCanvas.addEventListener('hide.bs.offcanvas', event => {
        // do something...
        navToggler.classList.remove('nav-terminate');
        nav.classList.remove('menu-open');
    })
    navOffCanvas.addEventListener('show.bs.offcanvas', event => {
        // do something...
        navToggler.classList.add('nav-terminate');
        nav.classList.add('menu-open');
    })
}

// FORM VALIDATION
    // Example starter JavaScript for disabling form submissions if there are invalid fields
    (() => {
        'use strict'

        // Fetch all the forms we want to apply custom Bootstrap validation styles to
        const forms = document.querySelectorAll('.needs-validation')

        // Loop over them and prevent submission
        Array.from(forms).forEach(form => {
            form.addEventListener('submit', event => {
                console.log('submit');
                if (!form.checkValidity()) {
                    event.preventDefault()
                    event.stopPropagation()
                } else {
                    progressModal.show();
                }

                form.classList.add('was-validated')
            }, false);
        });
    })();