function confirm_cert_download(e, elem){
	// for bill_on_download attorneys
	// confirm they want to download
	if(confirm("Download this certificate?")){
		// temporarily marks the column "Downloaded on mm/dd/yyyy"
		var d = new Date();
		var datestring = ("0"+(d.getMonth()+1)).slice(-2) + "/" +  ("0" + d.getDate()).slice(-2)  + "/" + d.getFullYear();
		var row = $(elem).closest('tr');
		row.find('.cert-download-status').text(datestring);
		// remove the onclick attribute if they click a 2nd time before refresh
		$(elem).removeAttr('onclick').siblings('a').removeAttr('onclick');
	} else {
		e.preventDefault();
	}
}

function edit_clients_district(e, elem){
	e.preventDefault();
	var i = 0;
	$.get("/attorneys/get_clients_district_form/"+$(elem).data('client-id'), function (data) {
		$('#district_modal .modal-body').html(data);
		$('#district_modal').modal('show');
	});
}

function get_clients_details(e, elem){
	e.preventDefault();
	var i = 0;
	$.get("/attorneys/get_clients_details_form/"+$(elem).data('client-id'), function (data) {
		$('#myModal .modal-content').html(data);
		$('#myModal').modal('show');
	});
}

function set_search_date(e,elem)
{
	e.preventDefault();
	$this = $(elem);
	$.get("/attorneys/get_activity/"+$('#search_from_date').val().replace(/\//g,'-')+"/"+$('#search_to_date').val().replace(/\//g,'-'), function (data) {
		$('#results').html(data);
		//dashboard client activity

	    $('#client_activity_hourly').highcharts({
	        data: {
	            table: 'client_activity_hourly_table'
	        },
	        chart: {
	            type: 'spline'
	        },
	        title: {
	            text: 'Hourly Client Activity'
	        },
	        yAxis: {
	            allowDecimals: false,
	            title: {
	                text: 'Units'
	            }
	        },
	        tooltip: {
	            formatter: function () {
	                return '<b>' + this.point.name + '</b><br/>' +
	                	this.series.name+ ': ' +this.point.y ;
	            }
	        }
	    });
	    $('#client_activity_weekly').highcharts({
	        data: {
	            table: 'client_activity_weekly_table'
	        },
	        chart: {
	            type: 'spline'
	        },
	        title: {
	            text: 'Weekly Client Activity'
	        },
	        yAxis: {
	            allowDecimals: false,
	            title: {
	                text: 'Units'
	            }
	        },
	        tooltip: {
	            formatter: function () {
	                return '<b>' + this.point.name + '</b><br/>' +
	                	this.series.name+ ': ' +this.point.y ;
	            }
	        }
	    });
	    $('#client_activity_monthly').highcharts({
	        data: {
	            table: 'client_activity_monthly_table'
	        },
	        chart: {
	            type: 'spline'
	        },
	        title: {
	            text: year+' Monthly Client Activity'
	        },
	        yAxis: {
	            allowDecimals: false,
	            title: {
	                text: 'Units'
	            }
	        },
	        tooltip: {
	            formatter: function () {
	            	return '<b>' + this.point.name + '</b><br/>' +
                	this.series.name+ ': ' +this.point.y ;
	            }
	        }
	    });
	});
}

function set_option(e, elem, id) {
	var value = null;
	var field = $(elem).attr('name');
	var return_value = true;
	if (!$(elem).is(':checked')) {
		var return_value = confirm("Are you sure you do not want us to file your certificates with the court?");
		$(elem).prop("checked", !return_value);
	}
	if ($(elem).attr('type') == 'checkbox') value = $(elem).is(':checked') ? 1 : 0;
	else value = $(elem).val();
	if(value == 0 || ($(elem).val() == 1 && return_value))
		$.post("/attorneys/functions/set_option", {id: id, field: field, value: value}, function (data) {

		});
}

function show_edits(e, elem){
	e.preventDefault();
	var $target = $($(elem).attr('href'));
	$($(elem).attr('href')+', [rel="'+$(elem).attr('href').replace('#', '')+'"]').toggleClass('d-none');
}

$(function(){
	$('.table-datatable').DataTable({
		'dom' : '<"dt-header-wrapper"<"row"<"col-4"l><"col-8"f>>><"table-responsive"t><"dt-footer-wrapper d-flex flex-column justify-content-center align-items-center"pi>',
		 "lengthMenu": [[10, 20, 50, -1], [10, 20, 50, "All"]],
		"oLanguage" : {
			"sLengthMenu": "_MENU_",
			"sSearch": "",
			"sFilterInput": '',
			"sInfoFiltered": ''
		}
	});
	var event = new UIEvent("change", {
        "view": window,
        "bubbles": true,
        "cancelable": true
    });
	if($('#search_from_date').length > 0)  document.getElementById('search_from_date').dispatchEvent(event);
    
    $('#search_from_date, #search_to_date').datepicker()
    .on('changeDate', function(e) {
        set_search_date(event,this);
    });

    // fixes highchart width in hidden tabs
    $(document).on( 'shown.bs.tab', 'a[data-toggle="tab"]', function (e) { // on tab selection event
        $( "#client_activity_weekly, #client_activity_monthly" ).each(function() { // target each element with the .contains-chart class
            var chart = $(this).highcharts(); // target the chart itself
            chart.reflow() // reflow that chart
        });
    })
  
    if($('#announcement_modal').length > 0){
    	if(show_announcement == 1) {
			 $(window).load(function(){
		        $('#announcement_modal').modal('show');
		    });
	    }
		
		 $('#announcement_modal [data-dismiss="modal"]').click(function(){
			 $.get('/attorneys/dismiss_announcement', function (data) {
			 
			 });
		 });
    }

    
	
});

